/**
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月13日
 */
package com.baofoo.DEMO;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;
import net.sf.json.JSONObject;
import com.baofoo.Entity.Result;
import com.baofoo.SMUtil.SM2;

import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;

public class OrderPay{
	/**
	 * 订单支付接口
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		
		String MemberId = "100028746";
		String TerminalId = "200003918";
	
		String SignPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_sign_02.sm2";
		String BFSignPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo02.cer";
	    String EncryptPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_enc_01.sm2";
	    String BFEncryptPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo01.cer";
	    
	    String signKeyPwd = "123456";
	    String encryptKeyPwd = "123456";
		
	    String NcrptnSn="4026170978";
	    String SignSn="1387287848";

		String PayType="guarantee";//交易方式  direct:直接结算（交易资金不过宝付）		guarantee:间接结算（由宝付结算）		freeze:冻结交易（需配合冻结交易附加字段使用）		直接结算:收款方信息必填
		
		String PayeeFreezeSign="";//冻结交易附加字段
		String PayeeBankNo="";//收款方开户行行号  pay_type为 direct必填
		String PayeeBankName="";//收款方开户行名称
		String PayeeAcctNo = "";//收款方账号
		String PayeeAcctName = "";//收款方账户名称
		String PayeeAcctType="";//收款方账户账户类型
		String PayeeUnifmCode="";//收款方信用代码
		String PayeeContactName="";//收款方联系人姓名
		String PayeeContactPhone="";//收款方联系电话
		
		String PayerBankNo="313100000013";//付款方开户行行号
		String PayerBankName="";//付款方开户行名称
		String PayerAcctNo = "82020171422920208";//付款方账号
		String PayerAcctName = "浙江香溢商务科技有限公司";//付款方账户名称
		String PayerAcctType="10";//付款方账户账户类型 01：银联卡（个人账户）	10：单位账户	40：备付金账户	99：其他
		String PayerUnifmCode="";//付款方信用代码
		String PayerContactName="";//付款方联系人姓名
		String PayerContactPhone="";//付款方联系电话
		
		String TxnAmt="5000";//交易金额
		String OrderExpTime="10";//订单过期时间
		String Remark="";//附言
		String Summary="";//业务摘要
		String ReturnUrl="http://10.0.60.66:8080/BaoFuOrderPayNotifyWeb/Notify.action";//业务通知地址
		String PayId="91020";//功能id
		String FeeMemberId="";//分账手续费商户
		String ShareInfo="";//分账信息
		String ShareNotifyUrl="";//分账结果通知地址

		Map<String,String> PostArry = new TreeMap<String,String>();
		PostArry.put("member_id", MemberId);//商户号
		PostArry.put("terminal_id", TerminalId);//终端号
		PostArry.put("version", "4.2");//验签方式
		PostArry.put("verify_type", "SM");//验签方式
		PostArry.put("ncrptn_sn", NcrptnSn);
		PostArry.put("sign_sn", SignSn);
		
		
		String TxnDate=new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());//报文发送日期时间
		String TransId = "TID"+System.currentTimeMillis();//商户订单号（格式：当天日期（yyyyMMdd）+商户自定议订单号）		
		Log.Write("订单号:"+TransId);
		Map<String,String> DataArry = new TreeMap<String,String>();
		DataArry.put("member_id", MemberId);
		DataArry.put("terminal_id", TerminalId);
		DataArry.put("txn_date", TxnDate);
		DataArry.put("trans_id", TransId);
		DataArry.put("pay_type", PayType);
		
//		DataArry.put("payee_freeze_sign", PayeeFreezeSign);
//		DataArry.put("payee_bank_no", PayeeBankNo);
//		DataArry.put("payee_bank_name", PayeeBankName);
//		DataArry.put("payee_acct_no", PayeeAcctNo);
//		DataArry.put("payee_acct_name", PayeeAcctName);
//		DataArry.put("payee_acct_type", PayeeAcctType);
//		DataArry.put("payee_unifm_code", PayeeUnifmCode);
//		DataArry.put("payee_contact_name", PayeeContactName);
//		DataArry.put("payee_contact_phone", PayeeContactPhone);
		
		DataArry.put("payer_bank_no", PayerBankNo);
//		DataArry.put("payer_bank_name", PayerBankName);
		DataArry.put("payer_acct_no", PayerAcctNo);
		DataArry.put("payer_acct_name", PayerAcctName);
		DataArry.put("payer_acct_type", PayerAcctType);
//		DataArry.put("payer_unifm_code", PayerUnifmCode);
//		DataArry.put("payer_contact_name", PayerContactName);
//		DataArry.put("payer_contact_phone", PayerContactPhone);		
		
		DataArry.put("txn_amt", TxnAmt);
		DataArry.put("order_exp_time", OrderExpTime);
//		DataArry.put("remark", Remark);
//		DataArry.put("summary", Summary);
		DataArry.put("return_url", ReturnUrl);
		DataArry.put("pay_id", PayId);
//		DataArry.put("fee_member_id", FeeMemberId);
//		DataArry.put("share_info", ShareInfo);
//		DataArry.put("share_notify_url", ShareNotifyUrl);				
		
		JSONObject Data_Content_Json = JSONObject.fromObject(DataArry);
		Log.Write("JSON:"+Data_Content_Json.toString());		
		String DataContent = SM2.encryptHex(BFEncryptPath, Data_Content_Json.toString());;//宝付公钥加密		
		PostArry.put("data_content", DataContent);		
		String SignVStr = FormatUtil.coverMap2String(PostArry);
		Log.Write("请求报文拼接:"+SignVStr);
		
		String VSignStr = SM2.sign(TerminalId, SignPrivatePath, signKeyPwd, SignVStr);
		PostArry.put("signature", VSignStr);
		
		String PostString  = HttpUtil.RequestForm("https://vgw.baofoo.com/neptune/orderPay", PostArry);	
		Log.Write("请求返回:"+PostString);

		if(!PostString.isEmpty()) {
			JSONObject Resulst_Json_Object = JSONObject.fromObject(PostString);
			Result Result_Object = (Result) JSONObject.toBean(Resulst_Json_Object, Result.class);
			if(Resulst_Json_Object.containsKey("signature")) {
				Resulst_Json_Object.remove("signature");				
			}
			Map<String, String> TempMap =  FormatUtil.JsonObjectToMap(Resulst_Json_Object);			
			String RSignVStr = FormatUtil.coverMap2String(TempMap);
			Log.Write("返回报文拼接:"+RSignVStr);
			Log.Write("返回签名:"+Result_Object.getSignature());
			
			if(SM2.verify0(TerminalId, BFSignPath, RSignVStr, Result_Object.getSignature())) {
				Log.Write("验签：YES");
				String RDataContent = SM2.decryptStr(Result_Object.getData_content(),EncryptPrivatePath,encryptKeyPwd);//宝付公钥加密			
				Log.Write("返回内容:"+RDataContent);
			}else {
				Log.Write("验签：NO");
			}
			
		}
		
	}
}