/**
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月13日
 */
package com.baofoo.DEMO;

import java.util.Map;
import java.util.TreeMap;
import net.sf.json.JSONObject;
import com.baofoo.Entity.Result;
import com.baofoo.SMUtil.SM2;

import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;

public class OrderPayQuery{
	/**
	 * 订单支付查询接口
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		
		String MemberId = "100028746";
		String TerminalId = "200003918";
	
		String SignPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_sign_02.sm2";
		String BFSignPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo02.cer";
	    String EncryptPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_enc_01.sm2";
	    String BFEncryptPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo01.cer";
	    
	    String signKeyPwd = "123456";
	    String encryptKeyPwd = "123456";
		
	    String NcrptnSn="4026170978";
	    String SignSn="1387287848";

	    String OrigTransId = "TID1683612606240";//原商户订单号 TID1683168353617
		Log.Write("查询订单号:"+OrigTransId);
		
		Map<String,String> PostArry = new TreeMap<String,String>();
		PostArry.put("member_id", MemberId);//商户号
		PostArry.put("terminal_id", TerminalId);//终端号
		PostArry.put("version", "4.2");//验签方式
		PostArry.put("verify_type", "SM");//验签方式
		PostArry.put("ncrptn_sn", NcrptnSn);
		PostArry.put("sign_sn", SignSn);
		
		
		
		Map<String,String> DataArry = new TreeMap<String,String>();
		DataArry.put("member_id", MemberId);
		DataArry.put("terminal_id", TerminalId);
		DataArry.put("orig_trans_id", OrigTransId);
		
		JSONObject Data_Content_Json = JSONObject.fromObject(DataArry);
		Log.Write("JSON:"+Data_Content_Json.toString());		
		String DataContent = SM2.encryptHex(BFEncryptPath, Data_Content_Json.toString());;//宝付公钥加密		
		PostArry.put("data_content", DataContent);		
		String SignVStr = FormatUtil.coverMap2String(PostArry);
		Log.Write("请求报文拼接:"+SignVStr);
		
		String VSignStr = SM2.sign(TerminalId, SignPrivatePath, signKeyPwd, SignVStr);
		PostArry.put("signature", VSignStr);
		
		String PostString  = HttpUtil.RequestForm("https://vgw.baofoo.com/neptune/queryOrderPay", PostArry);	
		Log.Write("请求返回:"+PostString);
		
		if(!PostString.isEmpty()) {
			JSONObject Resulst_Json_Object = JSONObject.fromObject(PostString);
			Result Result_Object = (Result) JSONObject.toBean(Resulst_Json_Object, Result.class);
			if(Resulst_Json_Object.containsKey("signature")) {
				Resulst_Json_Object.remove("signature");				
			}
			Map<String, String> TempMap =  FormatUtil.JsonObjectToMap(Resulst_Json_Object);			
			String RSignVStr = FormatUtil.coverMap2String(TempMap);
			Log.Write("返回报文拼接:"+RSignVStr);
			Log.Write("返回签名:"+Result_Object.getSignature());
			
			if(SM2.verify0(TerminalId, BFSignPath, RSignVStr, Result_Object.getSignature())) {
				Log.Write("验签：YES");
				String RDataContent = SM2.decryptStr(Result_Object.getData_content(),EncryptPrivatePath,encryptKeyPwd);//宝付公钥加密			
				Log.Write("返回内容:"+RDataContent);
			}else {
				Log.Write("验签：NO");
			}
			
		}
		
	}
}