package com.baofoo.SMUtil.Util;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;

/**
 * @author ximenchuixue
 * @since 2020/9/16
 */
public class BufReader {

    public static String read(String source) throws CryptoException{
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new StringReader(source));
            String line;
            StringBuilder buf = new StringBuilder();
            while((line = reader.readLine()) != null) {
                if (!line.startsWith("-")) {
                    buf.append(line);
                }
            }
            return buf.toString();
        } catch (IOException e) {
            throw new CryptoException("字符流读取异常", e);
        } finally {
            if (null != reader){
                try {
                    reader.close();
                } catch (IOException e) {
                    //ignore
                }
            }
        }
    }

    public static String read(byte[] source) throws CryptoException{
        if (null == source){
            throw new NullPointerException("源数据不能为空");
        }
        try {
            return read(new String(source, "UTF-8"));
        } catch (UnsupportedEncodingException e) {
            throw new CryptoException("字符编码异常", e);
        }
    }
}
