/**
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月22日
 */
package com.baofoo;

import java.util.Enumeration;
import java.util.Map;
import java.util.TreeMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baofoo.Entity.Result;
import com.baofoo.SMUtil.SM2;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.Log;

import net.sf.json.JSONObject;


public class WebController {
	
	public String Notify(HttpServletRequest request,HttpServletResponse response) throws Exception{

		request.setCharacterEncoding("utf-8");//utf-8编码接收
		Map<String,String> RDateArry = new TreeMap<String,String>();		
		Enumeration<String> e = request.getParameterNames();	
		while(e.hasMoreElements()) {
			String paraStr = e.nextElement();
			if(paraStr != null){
				RDateArry.put(paraStr, request.getParameter(paraStr));//接收参数,（使用TreeMap自动排序）
			}
		}
		
		JSONObject ResultJsonObject = JSONObject.fromObject(RDateArry);			
		Log.Write("接收异步通知参数："+ResultJsonObject.toString());
		
		Result Result_Object = (Result) JSONObject.toBean(ResultJsonObject, Result.class);	
		
		if(ResultJsonObject.containsKey("signature")) {
			ResultJsonObject.remove("signature");				
		}		
		Map<String, String> TempMap =  FormatUtil.JsonObjectToMap(ResultJsonObject);
		String RSignVStr = FormatUtil.coverMap2String(TempMap);
		Log.Write("返回报文拼接:"+RSignVStr);
		Log.Write("返回签名:"+Result_Object.getSignature());
		
		String Terminal_Id =  BaofooAction.getConstants().get("terminal_id");
		String BF_Sign_Cer = BaofooAction.getWebRoot()+"Cer\\"+BaofooAction.getConstants().get("bf_sign_cer");
		if(SM2.verify0(Terminal_Id, BF_Sign_Cer, RSignVStr, Result_Object.getSignature())) {
			Log.Write("验签：YES");
			String EncryptPrivatePath = BaofooAction.getWebRoot()+"Cer\\"+BaofooAction.getConstants().get("my_en_sm");
			String encryptKeyPwd = BaofooAction.getConstants().get("enc_pwd");
			String RDataContent = SM2.decryptStr(Result_Object.getData_content(),EncryptPrivatePath,encryptKeyPwd);//宝付公钥加密			
			Log.Write("解密返回内容:"+RDataContent);
		}else {
			Log.Write("验签：NO");
		}
		
		return "OK";
	}
}
